-- requires statistics to be up to date (including column distribution statistics)
connect to lsd:
select cast(a.tabschema as varchar(15)) as tab_schema,
       cast(a.tabname as varchar(27)) as tab_name,
       sum(case when typename = 'INTEGER' then 4 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'SMALLINT' then 2 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'BIGINT' then 8 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'REAL' then 4 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'DOUBLE' then 8 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'CHARACTER' then length + (case when nulls='Y' then 1 else 0 end)
                when typename = 'DECIMAL' then (length/2+1) + (case when nulls='Y' then 1 else 0 end)
                when typename = 'TIMESTAMP' then 10 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'DATE' then 4 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'TIME' then 3 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'VARCHAR' then 4 + (case when nulls='Y' then 1 else 0 end)
                when typename = 'LONG VARCHAR' then 24 + (case when nulls='Y' then 1 else 0 end)
                else 0 end) as Ohead_wo_VCompr,
       sum(case when typename = 'INTEGER' then 6
       when typename = 'SMALLINT' then 4
       when typename = 'BIGINT' then 10
       when typename = 'REAL' then 6
       when typename = 'DOUBLE' then 10
       when typename = 'CHARACTER' then length + 2
       when typename = 'DECIMAL' then (length/2+3)
       when typename = 'TIMESTAMP' then 12
       when typename = 'DATE' then 6
       when typename = 'TIME' then 5
       when typename = 'VARCHAR' then 2
       when typename = 'LONG VARCHAR' then 22  else 0 end)+2 as Ohead_w_VCompr,
       sum(avgcollen) as avg_row_len,
       cast(cast((select npages from syscat.tables where tabname=a.tabname and tabschema=a.tabschema) as double)*
                 (select pagesize from syscat.tablespaces where tbspace=(select tbspace from syscat.tables
                             where tabname=a.tabname and tabschema=a.tabschema)) /1000000 as integer) as Tot_mb_1,
       cast((select card from syscat.tables where tabname=a.tabname and tabschema=a.tabschema) as integer)
       as real_card,
       (select npages from syscat.tables where tabname=a.tabname and tabschema=a.tabschema) as npages,
       cast((select card from syscat.tables where tabname=a.tabname and tabschema=a.tabschema) as integer) /
       integer((
         ((select pagesize from syscat.tablespaces where tbspace=(select tbspace from syscat.tables where
         tabname=a.tabname and tabschema=a.tabschema))-76)
         /
         (sum(avgcollen) - sum(case when typename = 'INTEGER' then 4 + (case when nulls='Y' then 1 else 0 end)
         when typename = 'SMALLINT' then 2 + (case when nulls='Y' then 1 else 0 end) when typename = 'BIGINT'
         then 8 + (case when nulls='Y' then 1 else 0 end) when typename = 'REAL' then 4 + (case when nulls='Y'
         then 1 else 0 end) when typename = 'DOUBLE' then 8 + (case when nulls='Y' then 1 else 0 end) when
         typename = 'CHARACTER' then length + (case when nulls='Y' then 1 else 0 end) when typename = 'DECIMAL'
         then (length/2+1) + (case when nulls='Y' then 1 else 0 end) when typename = 'TIMESTAMP' then 10 +
         (case when nulls='Y' then 1 else 0 end) when typename = 'DATE' then 4 + (case when nulls='Y' then 1
         else 0 end) when typename = 'TIME' then 3 + (case when nulls='Y' then 1 else 0 end) when typename =
         'VARCHAR' then 4 + (case when nulls='Y' then 1 else 0 end) when typename = 'LONG VARCHAR' then 24 +
         (case when nulls='Y' then 1 else 0 end) else 0 end) + sum(case when typename = 'INTEGER' then 6 when
         typename = 'SMALLINT' then 4 when typename = 'BIGINT' then 10 when typename = 'REAL' then 6 when
         typename = 'DOUBLE' then 10 when typename = 'CHARACTER' then length + 2 when typename = 'DECIMAL'
         then (length/2+3) when typename = 'TIMESTAMP' then 12 when typename = 'DATE' then 6 when typename =
         'TIME' then 5 when typename = 'VARCHAR' then 2 when typename = 'LONG VARCHAR' then 22 else 0 end)+2 )
           ) ) as npage_ohead_est,
       cast((select card from syscat.tables where tabname=a.tabname and tabschema=a.tabschema) as integer) /
       integer((
         ((select pagesize from syscat.tablespaces where tbspace=(select tbspace from syscat.tables where
         tabname=a.tabname and tabschema=a.tabschema))-76) /
         (sum(avgcollen) - sum(case when typename = 'INTEGER' then 4 + (case when nulls='Y' then 1 else 0 end)
         when typename = 'SMALLINT' then 2 + (case when nulls='Y' then 1 else 0 end) when typename = 'BIGINT'
         then 8 + (case when nulls='Y' then 1 else 0 end) when typename = 'REAL' then 4 + (case when nulls='Y'
         then 1 else 0 end) when typename = 'DOUBLE' then 8 + (case when nulls='Y' then 1 else 0 end) when
         typename = 'CHARACTER' then length + (case when nulls='Y' then 1 else 0 end) when typename = 'DECIMAL'
         then (length/2+1) + (case when nulls='Y' then 1 else 0 end) when typename = 'TIMESTAMP' then 10 + (case
         when nulls='Y' then 1 else 0 end) when typename = 'DATE' then 4 + (case when nulls='Y' then 1 else 0 end)
         when typename = 'TIME' then 3 + (case when nulls='Y' then 1 else 0 end) when typename = 'VARCHAR' then 4 +
         (case when nulls='Y' then 1 else 0 end) when typename = 'LONG VARCHAR' then 24 + (case when nulls='Y' then
         1 else 0 end) else 0 end) + sum(case when typename = 'INTEGER' then 6 when typename = 'SMALLINT' then 4 when
         typename = 'BIGINT' then 10 when typename = 'REAL' then 6 when typename = 'DOUBLE' then 10 when typename =
         'CHARACTER' then length + 2 when typename = 'DECIMAL' then (length/2+3) when typename = 'TIMESTAMP' then 12
         when typename = 'DATE' then 6 when typename = 'TIME' then 5 when typename = 'VARCHAR' then 2 when typename
         = 'LONG VARCHAR' then 22 else 0 end)+2
--
           - (select sum(cast(((b.avgcollen*(k.valcount*100))/c.card)/100 as decimal(5,2))) as saved_length
                   from syscat.coldist k join syscat.columns b on k.tabname=b.tabname and k.tabschema=b.tabschema
                   and k.colname=b.colname
                                                     join syscat.tables c on k.tabname=c.tabname and
                                                     k.tabschema=c.tabschema
                            where
                           (case when b.typename='DECIMAL' then cast(cast(colvalue as decimal(10,2)) as char(22))
                            when b.typename='CHARACTER' then
                            cast(substr(substr(colvalue,2),1,posstr(colvalue,'''')) as char(22))
--                          when b.typename='VARCHAR' then cast(colvalue as char(22))
                            when b.typename='SMALLINT' then cast(colvalue as char(22))
                            when b.typename='INTEGER' then cast(colvalue as char(22))
                            when b.typename='BIGINT' then cast(colvalue as char(22))
                            when b.typename='DOUBLE' then cast(colvalue as char(22))
                             end)=
                            (case when b.typename='DECIMAL' then cast(cast(0 as decimal(10,2)) as char(22))
                            when b.typename='CHARACTER' then cast(' ' as char(1))
--                          when b.typename='VARCHAR' then NULL
                            when b.typename='SMALLINT' then cast(0 as char(22))
                            when b.typename='INTEGER' then cast(0 as char(22))
                            when b.typename='BIGINT' then cast(0 as char(22))
                            when b.typename='DOUBLE' then cast(colvalue as char(22))
                             end) and
                             c.tabname = a.tabname and
--                             k.colname=b.colname and
                             seqno=1 and
                             k.type='F')
--
           ) ) ) as new_npage_est
from syscat.columns a join syscat.tables t on a.tabname=t.tabname and a.tabschema=t.tabschema
where t.type='T'
and a.tabname ='ZZZZZZZZZZZ'
group by a.tabschema, a.tabname
order by tot_mb_1 desc
;

